Redmine - Defect #40716

"Edit this section” on Wiki pages misinterprets issue links with double hash (##nnn) as ATX
headings

2024-05-22 05:25 - daijiro fukuda

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Wiki Estimated time: 0.00 hour
Target version: 5.1.4

Resolution: Fixed Affected version: 5.1.2
Description

Abstraction

"Edit this section" in Wiki with the Markdown syntax does not extract ATX headings correctly.

ATX headings:

# Headline

## Headline

The current trunk(rev.22841) and v5.0.2 extracts it by the regexp '#+.+', but this would not be sufficient.

Especially, since it does not consider the following condition, it mishandles ticket references such as "#11111" or "##11111".

The opening sequence of # characters must be followed by a space or by the end of line.

| explain the details in "How to reproduce”.

How to reproduce

Prepare Wiki with the Markdown syntax as follows.
# Wiki

## Section A

A

##1 : this is a ticket reference.

AR

## Section B

B
https://github.github.com/gfm/#atx-heading

how-to-reproduce-sample1-entire.png
We can click each section's "Edit this section" button (surrounded by red rectangles in the image above).
However, we can't edit each section correctly since the ticket reference "##1" is wrongly detected as a level 2 section.

When clicking the button of "Section A"
(URI: "Wiki/edit?section=2")
how-to-reproduce-sample1-edit-section2.png
When clicking the button of "Section B™:
(URI: "Wiki/edit?section=3")
how-to-reproduce-sample1-edit-section3.png
The expected result when clicking the button of "Section A":

## Section A

A

##1 : this is a ticket reference.

AR

The expected result when clicking the button of "Section B":
## Section B

B

Environment

$ RAILS_ENV=development bin/about

Environment:
Redmine version 5.1.2.devel
Ruby version 3.2.2-p53 (2023-03-30) [x86_64-1inux]
Rails version 7.1.2
Environment development
Database adapter SQLite
Mailer queue ActivedJob: :QueueAdapters: :AsyncAdapter
Mailer delivery smtp
Redmine settings:
Redmine theme Default
SCM:
Subversion 1.13.0
Git 2.25.1
Filesystem

Redmine plugins:
no plugin installed

How should we fix this?

It would be necessary to improve the regular expression based on GitHub Flavored Markdown
(because the commonmarker is wrapping comrak, and comrak is based on GitHub Flavored Markdown.)

The current (rev.22841) regexp for ATX headings is '#+.+' as follows.

https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735¢c174e7¢79e97254e75/lib/redmine/wiki_formatting/section_helper
.rb#l 45

@text.split (/ (M (2:\SH\r2\n\r? (?:\=+|\—+) [#+.+] (2:~~~| ") .*)\s*S)/) .each do |part]

https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7¢79e97254e75/lib/redmine/wiki_formatting/section_helper
.rb#L 55-L56

elsif part =~ /\A(#+).+/
level = $l.size

For example, we can make these conditions consider spaces following to the opening '#'.
(I have uploaded this patch file.)

Index: lib/redmine/wiki_formatting/section_helper.rb

—-—— lib/redmine/wiki_formatting/section_helper.rb (revision 22841)
+++ lib/redmine/wiki_formatting/section_helper.rb (working copy)
@@ -42,7 +42,7 @@

i=0
https://github.github.com/gfm
https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper.rb#L45
https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper.rb#L45
https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper.rb#L55-L56
https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper.rb#L55-L56

1 =1

inside_pre false

= @text.split (/ (" (2:\S+\r?2\n\r? (?:\=+|\—4) [#+.+]| (?:~~~]| ") .*)\s*$) /) .each do |part]|

+ @text.split (/ (M (2:\S+\r2\n\r?2 (2:\=+|\=+) [#+ +.+| (2:~~~] " ).*)\s*$) /) .each do |part]|
level = nil
if part =~ /\A(~{3,} 1 {3,}) (\s*\S+) ?2\s*$/

if 'inside_pre
@@ -52,7 +52,7 @@
end

elsif inside_pre

# nop
- elsif part =~ /\A(#+).+/
+ elsif part =~ /\A(#+) +.+/
level = $l.size
elsif part =~ /\A.+\r?\n\r? (\=+|\-+)\s*$/
level = $1l.include?('=') 2 1 : 2

This solves the case | explained in "How to reproduce”, but this is not enough to handle the following headlines.
# Headline may have some spaces in the line head.
#(\t) Tab can be replaced to spaces

| often use ticket references, so I'm happy to solve just the case | explained in "How to reproduce” first.

Related issues:
Has duplicate Redmine - Defect #40715: Wiki (markdown syntax): "Edit this sec... Closed

Associated revisions

Revision 22905 - 2024-07-06 09:35 - Go MAEDA
Fix RuboCop offense Style/RedundantRegexpEscape in lib/redmine/wiki_formatting/section_helper.rb (#40716).

Revision 22906 - 2024-07-06 09:44 - Go MAEDA
Prevent issue links with double hash (##nnn) from being recognized as ATX headings (#40716).

Patch by daijiro fukuda (user:daipom).

Revision 22907 - 2024-07-06 09:46 - Go MAEDA
Add test for r22906 (#40716).

Revision 22918 - 2024-07-10 11:33 - Go MAEDA
Merged r22905, r22906, and r22907 from trunk to 5.1-stable (#40716).

History

#1 - 2024-05-22 05:32 - daijiro fukuda

| have confirmed the following with the uploaded patch: wiki-fix-section-extracting-mishandles-ticket-refs.diff.

e the case described in "How to reproduce” is resolved
¢ No failure in the tests

My view on the fix is as explained in "How should we fix this?".

If you think a more drastic fix is needed, please point it out.
Thanks!

#2 - 2024-05-22 08:38 - Marius BALTEANU
- Has duplicate Defect #40715: Wiki (markdown syntax): "Edit this section" does not extract ATX headings correctly added

#3 - 2024-05-22 11:38 - Go MAEDA

- Status changed from New to Confirmed

#4 - 2024-06-27 11:48 - Mark Asbach

daijiro fukuda wrote in #note-1:
If you think a more drastic fix is needed, please point it out.

I've stumbled upon this issue as we experience a (most probably) related issue, but for setext Headings in MarkDown (

https://github.qithub.com/gfm/#setext-heading). Because I'm not 100% sure this is the same root cause, I've created a new ticket (#40918), but if my
assumption is right, a more drastic fix would be good to solve both issues.

Unfortunately, I'm no rails developer and so cannot provide a patch or pull request with sufficient quality. In case you find the time to look at the issue

reported by me, I'd be very grateful for that.

Thanks!

#5 - 2024-07-04 08:28 - Go MAEDA
- File test-40716.patch added

- Target version set to 5.1.4

Thank you for posting the patch to fix the issue. | wrote a test for the

Setting the target version to 5.1.4.

#6 - 2024-07-06 09:49 - Go MAEDA

patch.

- Subject changed from Wiki (markdown syntax): "Edit this section" does not extract ATX headings correctly to "Edit this section" on Wiki pages

misinterprets issue links with double hash (##nnn) as ATX headings
- Status changed from Confirmed to Resolved
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22906.
Thank you for your contribution.

#7 - 2024-07-10 11:34 - Go MAEDA

- Status changed from Resolved to Closed

Merged the changes to 5.1-stable in r22918.

#8 - 2024-07-10 11:38 - daijiro fukuda

Thanks for merging!

About Defect #40918: Wiki (markdown syntax): "Edit this section" does not extract SeText headings correctly (#note-4),

I'll take a look if | have time.

Files

how-to-reproduce-sample1-edit-section3.png
how-to-reproduce-sample1-edit-section2.png
how-to-reproduce-sample1-entire.png
wiki-fix-section-extracting-mishandles-ticket-refs.diff
test-40716.patch

2025-05-21

14.6 KB
14 KB
50.1 KB
903 Bytes
1.03 KB

2024-05-22
2024-05-22
2024-05-22
2024-05-22
2024-07-04

daijiro fukuda
daijiro fukuda
daijiro fukuda
daijiro fukuda

Go MAEDA

6/6


https://github.github.com/gfm/#setext-heading
https://www.redmine.org/issues/40918
https://www.redmine.org/projects/redmine/repository/svn/revisions/22906
https://www.redmine.org/projects/redmine/repository/svn/revisions/22918
https://www.redmine.org/issues/40918
http://www.tcpdf.org

